#include <stdio.h>
#include <stdlib.h>

#include <cuda.h>
#include <curand.h>

__host__ void PrintArray ( float * a, const int size ) {
   printf("{ ");
   for ( int i = 0 ; i < size ; i++)  { 
   		printf("%2f ", a[ i ] ); 
   }
   printf("}\n");
}

int main ( void ) {
	int ARRAY_SIZE = 128;
	int ARRAY_BYTES = ARRAY_SIZE * sizeof(float);
	float *d_array;
	float h_array[ARRAY_SIZE];

    cudaMalloc( (void**)&d_array, ARRAY_BYTES ) ;

	curandGenerator_t gen;
	curandCreateGenerator( &gen, CURAND_RNG_PSEUDO_DEFAULT );
	curandSetPseudoRandomGeneratorSeed( gen, 1234ULL );
	curandGenerateUniform( gen, d_array, ARRAY_SIZE );

	cudaMemcpy( h_array, d_array, ARRAY_BYTES, cudaMemcpyDeviceToHost);

	PrintArray ( h_array, ARRAY_SIZE );
	
	curandDestroyGenerator( gen );
	cudaFree( d_array );

	return 0;
}