#include <stdio.h>
#include <iostream>

__host__ void PrintArray ( int * array, const int size ) {
   printf("{ ");
   for ( int i = 0 ; i < size ; i++ ) { 
   	printf("%d ", array[i]); 
   }
   printf("}\n");
}

__global__ void Square ( int * d_in, int * d_out ) {
	int idx = threadIdx.x;
	int val = d_in[ idx ];
	d_out[ idx ] = val * val;
}

int main ( void ) {
	int ARRAY_SIZE = 128;
	int ARRAY_BYTES = ARRAY_SIZE * sizeof(int);
	int h_array[ ARRAY_SIZE ];
	int * d_in, * d_out;

	for ( int i = 0 ; i < ARRAY_SIZE ; ++ i ) {
		h_array[ i ] = i;
	}

	cudaMalloc( (void**)&d_in, ARRAY_BYTES );
	cudaMalloc( (void**)&d_out, ARRAY_BYTES );

	cudaMemcpy( d_in, h_array, ARRAY_BYTES, cudaMemcpyHostToDevice );

	Square<<<1, ARRAY_SIZE>>>( d_in, d_out );
	
	cudaMemcpy( h_array, d_out, ARRAY_BYTES, cudaMemcpyDeviceToHost );

	PrintArray( h_array, ARRAY_SIZE );

	cudaFree( d_in );
	cudaFree( d_out );	
	return 0;
}
